//
//  Multiple precision integer class Mint  Ver 2.40
//
//  Copyright (C) by S.Tomabechi 1993-2000
//     All rights reserved.
//
#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#ifdef __BORLANDC__
#define WIN32
#endif

#ifndef WIN32
#define __LINUX__
#endif

#ifndef __MINT_HPP
#define __MINT_HPP

//#include <vector>
//using namespace std ;
#include <iostream.h>
#include "FFT.hpp"
#ifdef _MEMMAN
#  include "MemMan.hpp"                 // for debugging
#endif

#ifdef __BORLANDC__
#pragma warn -lvc
#pragma option -r-
#endif

#define _digits_1line 15

#define NBITS (32)                      // number of bits of RADIX
                                        // ñΥӥåȿ
#define NBYTE (4)                       // number of bytes of RADIX
                                        // ñΥХȿ
#define _decimal (100000UL)             // RADIX
                                        // ɽݤδ  10^5
#define AbsoluteRem   2                 // the least absolute residue
                                        // кǾ;
#define PositiveRem   1                 // the least positive residue
                                        // Ǿ;
#define SameSignRem 0                   // the residue with same signatue of numbr to de divided
                                        // Ʊξ;
#define _POSITIVE_  0x01ffffff
#define _NEGATIVE_  0xff000000
#define _DIGITS_    0x00ffffff          // 礭ФΥޥ
//#define MAX_DIGITS  (0x00100000)        // maximum size of array 2^20
#define MAX_DIGITS  (0x00ffffff)        // maximum size of array 2^20
                                        // 礭κ 2^20


#ifndef __BORLANDC__            // offsets of member data
                                // ХǡΥ饹ˤ륪եå.
#  define DIGIT   0             // Хǡ¤ӤѹȤ
#  define NDIGIT  4           // ΥեåȤͤѹ뤳.
#  define FDIGIT  8
#  define NDIM    12
#  define SIGN    15
#endif

#define isEqual 0
#define isGreater 1
#define isLess -1

//#define _FFT_BIT_       (11)
#define _FFT_BIT_         (14)
#define _FFT_DIGIT_       (1<<_FFT_BIT_)
#define NUM_OF_FFT_SCHEME (23-(_FFT_BIT_-11))
#define _KARATSUBA_DIGIT_ (60)
#define _TOOM3_DIGIT_      (600)
#define _SQUARE_DIGIT_    (2*60)

enum Format { noSpace,digit5,noFormat } ;
                                   // output format
                                   // Ϸ
                                   // digit5 ϡ5 ˰ blank 졢
                                   // 50 ǲԡ
                                   // noFormat Ϣ³ʸȤƽϡ

class Mint ;                       // integer
                                   // 
class Fint ;                       // real number
                                   // ¿
class Rational ;                   // rational number
                                   // ͭ
class Complex ;                    // complex
                                   // ʣǿ
class MBit ;                       // template for treatinf integer as bit string
class Mont ;                       // Montgomery reduction class
class FFT ;                        // Fast Fourier Transformation
class PolyM ;                      // polynomial with coefficients Mint
                                   // ѿ¿༰  Mint
class PolyL ;                      // polynomial with coefficients long integer
                                   // ѿ¿༰  long
class PolyFp ;
class ECPt ;

struct PPrimes ;
struct RPrimes ;
struct APrimes ;
//class PVector<Mint> ;

class Mint
{

    friend class Fint ;            // derived class

    friend class Rational ;        // classes using class Mint
    friend class Complex ;
    friend class MBit ;
    friend class Mont ;
    friend class FFT ;
    friend class PolyM ;
    friend class PolyL ;
    friend class PolyFp;
    friend class ECPt ;
                                   // member data
#ifdef _MEMMAN
public:
    static MemMan _MemMan ;        // ҡץ饹(ǥХå)
    void   check(char* file,int line) const ;
#endif
public:
public:
    Mint(int size,int fisze) ;     // non-public constructor

    unsigned long* digit ;         // array of digits
                                   // Ƭɥ쥹
    int nDigit ;                   // number of siginificant digits
                                   // ͭ
    int fDigit ;                   // size of fractional part ( always 0 in class Mint)
                                   // η  Υ饹ǤϾ 0
    int nDim ;                     // size of array and sign
                                   // [sign (1 byte) | size (3 bytes)]
                                   // 礭  

                                   // member functions
public:
Mint& isRem2(const Mint& a,const long s) ;
//Mint& pfactorial(unsigned long a,unsigned long b,unsigned long ndiv=1<<8) ;
                                   // constructors
    Mint() ;                       // default value = 0
    Mint(const short n) ;
    Mint(const int n) ;
    Mint(const long n) ;
    Mint(const unsigned long n) ;
    Mint(const char* const c) ;
    Mint(const Mint& a) ;          // copy constructor

    inline ~Mint() ;               // destructor

                                 // assignment operator
                                 // ʷˤƤΤ
                                 // sizeof(int)!=sizeof(long)  16bit DOS
                                 // ΤȤ˳ȯ줿̾Ĥ.
                                 // ޤʤ顢int,unsigned int ΤդĤ
                                 // Τ޺Ƥ
                                 // бΤݤޤ
                                 //  CPU,OS Ǥ sizeof(int)!=sizeof(long)
                                 // Ȥä𶷤뤫ΤʤΤǤʤ
    Mint& operator=(const Mint& a) ;
    Mint& operator=(const short a) ;
    Mint& operator=(const int a) ;
    Mint& operator=(const long a) ;
    Mint& operator=(const unsigned long a) ;
    Mint& operator=(const char* const Number) ;  // 32ӥåȰʾ
    Mint& operator=(const double& d) ;
    Mint& operator=(const long double& d) ;
    Mint& operator=(const Fint& f) ;

    // operators

    Mint  operator%(const Mint& n) const ; // residue
    long  operator%(const short n) const ; // ;
    long  operator%(const int n) const ;
    long  operator%(const long n) const ;
    Mint  operator%(const unsigned long n) const ;

    Mint  operator&(const Mint& n) const ; // the least positive residue
                                           //Ǿ;
    long  operator&(const short n) const ;
    long  operator&(const int n) const ;
    long  operator&(const long n) const ;
    unsigned long operator&(const unsigned long n) const ;

    Mint  operator^(const Mint& n) const ; // the least absolute residue
                                            // ͺǾ;
    long  operator^(const short n) const ;
    long  operator^(const int n) const ;
    long  operator^(const long n) const ;
    Mint  operator^(const unsigned long n) const ;

    Mint  operator>>(const int s) const ;  // shift
    Mint  operator<<(const int s) const ;
    Mint  operator>>(const long s) const ;
    Mint  operator<<(const long s) const ;
    Mint  operator>>(const unsigned long s) const ;
    Mint  operator<<(const unsigned long s) const ;

    Mint& operator>>=(const int s) ;
    Mint& operator<<=(const int s) ;
    Mint& operator>>=(const long s) ;
    Mint& operator<<=(const long s) ;
    Mint& operator>>=(const unsigned long s) ;
    Mint& operator<<=(const unsigned long s) ;

#if 1
    Mint& isAND(const Mint& a,const Mint& c) ;  // ߥƥ
    Mint& isOR(const Mint& a,const Mint& c) ;   //  private ˤʤ뤫
    Mint& isXOR(const Mint& a,const Mint& c) ;  // 뤤Ϥʤʤ뤫Τʤ
#endif

    bool  operator>(const Mint& n) const ;
    bool  operator>(const short n) const ;
    bool  operator>(const int n) const ;
    bool  operator>(const long n) const ;
    bool  operator>(const unsigned long n) const ;

    bool  operator<(const Mint& n) const ;
    bool  operator<(const short n) const ;
    bool  operator<(const int n) const ;
    bool  operator<(const long n) const ;
    bool  operator<(const unsigned long n) const ;

    bool  operator>=(const Mint& n) const ;
    bool  operator>=(const short n) const ;
    bool  operator>=(const int n) const ;
    bool  operator>=(const long n) const ;
    bool  operator>=(const unsigned long n) const ;

    bool  operator<=(const Mint& n) const ;
    bool  operator<=(const short n) const ;
    bool  operator<=(const int n) const ;
    bool  operator<=(const long n) const ;
    bool  operator<=(const unsigned long n) const ;

    bool  operator==(const Mint& b) const ;
    bool  operator==(const short n) const ;
    bool  operator==(const int n) const ;
    bool  operator==(const long n) const ;
    bool  operator==(const unsigned long n) const ;

    bool  operator!=(const Mint& n) const ;
    bool  operator!=(const short n) const ;
    bool  operator!=(const int n) const ;
    bool  operator!=(const long n) const ;
    bool  operator!=(const unsigned long n) const ;

    Mint& operator+=(const Mint& b) ;
    Mint& operator+=(const short n) ;
    Mint& operator+=(const int n) ;
    Mint& operator+=(const long n) ;
    Mint& operator+=(const unsigned long n) ;
    Mint& operator+=(const Fint& f) ;

    Mint& operator-=(const Mint& b) ;
    Mint& operator-=(const short n) ;
    Mint& operator-=(const int n) ;
    Mint& operator-=(const long n) ;
    Mint& operator-=(const unsigned long n) ;
    Mint& operator-=(const Fint& f) ;

    Mint& operator*=(const Mint& a) ;
    Mint& operator*=(const short n) ;
    Mint& operator*=(const int n) ;
    Mint& operator*=(const long n) ;
    Mint& operator*=(const unsigned long n) ;

    Mint& operator/=(const Mint& b) ;
    Mint& operator/=(const short n) ;
    Mint& operator/=(const int n) ;
    Mint& operator/=(const long n) ;
    Mint& operator/=(const unsigned long n) ;

    Mint& operator%=(const Mint& n) ;
    Mint& operator%=(const short n) ;
    Mint& operator%=(const int n) ;
    Mint& operator%=(const long n) ;
    Mint& operator%=(const unsigned long n) ;

    Mint& operator&=(const Mint& n) ;         // Ǿ;
    Mint& operator&=(const short n) ;         // ؤǰ̤˰;
    Mint& operator&=(const int n) ;
    Mint& operator&=(const long n) ;
    Mint& operator&=(const unsigned long n) ;

    Mint& operator^=(const Mint& n) ;        // ͺǾ;
    Mint& operator^=(const short n) ;
    Mint& operator^=(const int n) ;
    Mint& operator^=(const long n) ;
    Mint& operator^=(const unsigned long n) ;


    Mint& operator++() ;    // ++x prefix
    Mint  operator++(int) ; // x++ postfix

    Mint& operator--() ;    // --x prefix
    Mint  operator--(int) ; // x-- postfix

    Mint  operator+() const ;
    Mint  operator-() const ;  // negation
    Mint& operator~() ;        // x=-x
    bool  operator!() ;

          operator long() const ;       // conversion operator
          operator unsigned long() const  ;
          operator int() const ;
          operator double() const ;
          operator long double() const ;

    Mint& operator[](const long s) ;    // shift as 2^32-adic number
    Mint  operator()(const long s) const ;

    Mint& power(const Mint& x,const Mint& n,const Mint& p) ;
    Mint& apower(const Mint& x,const Mint& n,const Mint& p) ;

    int  ndigit(void) const ;          // return number of significant digits
                                        // ֤ͭ
    int  fdigit(void) const ;           // return length of fractional part
                                        // η֤

    bool   isZero(void) const ;         // check whether a number is zero
    bool   isPositive(void) const ;     // positive ?
    bool   isNegative(void) const ;     // negative ?
    bool   isEven(void) const ;         // even number ?
    bool   isOdd(void) const ;          // odd number ?

                         // friend operators
    friend Mint operator+(const Mint& n,const Mint& d) ;
    friend Mint operator+(const Mint& n,const short d) ;
    friend Mint operator+(const Mint& n,const int d) ;
    friend Mint operator+(const Mint& n,const long d) ;
    friend Mint operator+(const Mint& n,const unsigned long d) ;

    friend Mint operator+(const short n,const Mint& a) ;
    friend Mint operator+(const int n,const Mint& a) ;
    friend Mint operator+(const long n,const Mint& a) ;
    friend Mint operator+(const unsigned long n,const Mint& a) ;
    friend Mint operator-(const Mint& n,const Mint& m) ;
    friend Mint operator-(const Mint& n,const short d) ;
    friend Mint operator-(const Mint& n,const int d) ;
    friend Mint operator-(const Mint& n,const long d) ;
    friend Mint operator-(const Mint& n,const unsigned long d) ;
    friend Mint operator-(const short n,const Mint& a) ;
    friend Mint operator-(const int n,const Mint& a) ;
    friend Mint operator-(const long n,const Mint& a) ;
    friend Mint operator-(const unsigned long n,const Mint& a) ;

    friend Mint operator*(const Mint& n,const Mint& d) ;
    friend Mint operator*(const Mint& n,const unsigned long d) ;
    friend Mint operator*(const Mint& n,const long d) ;
    friend Mint operator*(const Mint& n,const int d) ;
    friend Mint operator*(const Mint& n,const short d) ;
    friend Mint operator*(const short n,const Mint& a) ;
    friend Mint operator*(const int n,const Mint& a) ;
    friend Mint operator*(const long n,const Mint& a) ;
    friend Mint operator*(const unsigned long n,const Mint& a) ;

    friend Mint operator/(const Mint& n,const Mint& d) ;
    friend Mint operator/(const Mint& n,const unsigned long d) ;
    friend Mint operator/(const Mint& n,const long d) ;
    friend Mint operator/(const Mint& n,const int d) ;
    friend Mint operator/(const Mint& n,const short d) ;

    friend Mint  mod(const Mint& n,const Mint& p) ;
    friend long  mod(const Mint& n,const long p) ;
    friend unsigned long mod(const Mint& n,const unsigned long p) ;
    friend int   mod(const Mint& n,const int p) ;
    friend short mod(const Mint& n,const short p) ;
    friend Mint  amod(const Mint& n,const Mint& p) ;
    friend long  amod(const Mint& n,const long p) ;
    friend Mint  amod(const Mint& n,const unsigned long p) ;
    friend int   amod(const Mint& n,const int p) ;
    friend short amod(const Mint& n,const short p) ;

    friend Rational operator/(const Mint& n,const Rational& q) ;
    friend Rational operator/(const long n,const Rational& q) ;

    friend Format SetFormat(Format form) ;  // set output format

                                 // inout and output numbers
    friend ::ostream& operator<<(::ostream& os,const Mint& a) ;
    friend ::istream& operator>>(::istream& is,Mint& a) ;
    friend ::ostream& operator<<(::ostream& os,const Fint& a) ;
    friend ::istream& operator>>(::istream& is,Fint& a) ;

                                 // function for debug
    friend ::ostream& component(::ostream& os,const Mint& a) ;

                                 // read and  write as binary data
    friend void write(::ostream& os,const Mint& n) ;
    friend void read(::istream& is,Mint& n) ;

                                     // absolute value
    friend Mint abs(const Mint& n) ;
    friend Fint abs(const Fint& f) ;
                                     // u=q*v+r  (Euclidean division with remainder)
    friend void divide(const Mint& u,const Mint& v,Mint& q,Mint& r) ;
    friend Mint gcd(const Mint& a,const Mint& b) ;    // greatest common divisor
    friend Mint agcd(const Mint& a,const Mint& b) ;
    friend Mint ceil(const Fint& f) ;
    friend void GCD(long nAray,Mint* q,Mint& g,unsigned long nPrimes,unsigned long* Primes);

    friend Mint egcd(const Mint& a,const Mint& b,Mint& u,Mint& v) ; // extended gcd
    friend PolyM egcd(const PolyM& u,const PolyM& v,
                      PolyM& v1,PolyM& v2,Mint& v3) ;
    friend Mint floor(const Fint& f) ;
    friend Mint invmodp(const Mint& a,const Mint& p) ;
    friend unsigned long invmodp(const Mint& a,const unsigned long p) ;
    friend Mint Int(const Fint& a) ;
    friend long Kronecker(const Mint& a,const Mint& b) ;
    friend bool Hensel(Mint* A,PolyL& fL) ;
    friend bool Hensel(Mint* A,PolyM& fL) ;
    friend void Hensel_init(int& nsol,PolyFp* sol,bool irred) ;
    friend void Mul(Mint* x,Mint* y,Mint* xy) ;
    friend void MulP(Mint* x,Mint* y,Mint* xy,Mint& p) ;
    friend void MulP(Mint* X,Mint* Y,Mint* XY,unsigned long P) ;
    friend void Mul(PolyM& X,PolyM& Y,PolyM& XY) ;
    friend void Mul(const PolyM& X,const PolyM& Y,PolyM& XY) ;

    friend void Product(long A,unsigned long B,Mint* PAB) ;
    friend void Product(long la,unsigned long b,Mint* PAB,PolyM& g) ;
    friend Mint p_11(const Mint& N,Mint& x,const unsigned long B) ;
    friend Mint p_1(const Mint& N,const unsigned long B1) ;
    friend Mint power(const Mint& x,const Mint& n,const Mint& p) ;
    friend Mint power(const Mint& x,unsigned long n) ;
    friend Mint power(const long,unsigned long n) ;
    friend Mint power(const int,unsigned long n) ;
    friend Mint power(const unsigned long,unsigned long n) ;
    friend Fint power(const Fint& x,const Mint& n) ;
    friend Complex power(const Complex& x,const Mint& n) ;
    friend Mint apower(const Mint& x,const Mint& n,const Mint& p) ;
    friend unsigned long prmdiv(const Mint& n,const unsigned long) ;
    friend Mint large_factor(const Mint& n,const unsigned long MAX_DIVISOR) ;
//  friend Mint factorial(unsigned long n) ;
    friend Mint pfactorial(unsigned long a,unsigned long b,unsigned long ndiv) ;
    friend Mint qfactorial(unsigned long a,unsigned long b,unsigned long ndiv) ;

    friend unsigned long prmdiv11(const Mint& n,const unsigned long) ;
    friend int  sign(const Mint& n) ;
    friend Mint sqrt(const Mint& n) ;
    friend Mint sqrt_Shanks(const Mint& a,const Mint& p) ;
    friend Mint square(const Mint& a) ;
    friend int  Val2(const Mint& N) ;
    friend Mint nearInt(const Mint& a,const Mint& b) ;
    friend Mint floorInt(const Mint& a,const Mint& b) ;

    friend bool Even(const Mint& n) ;
    friend bool Odd(const Mint& n) ;

//    friend Mint AND(const Mint& a,const Mint& c) ;
//    friend Mint OR(const Mint& a,const Mint& c) ;
//    friend Mint XOR(const Mint& a,const Mint& c) ;

    friend Mint ecm(const Mint& N,int itry,unsigned long maxL1) ;
    friend Mint PPMPQS(const Mint& N) ;
    friend void DivideByBase(void) ;
    friend void DivideByBase(unsigned long nPrimes,PPrimes* Primes);

    friend void DivideByBaseRodd(unsigned long nPrimes,RPrimes* PrimesR,long A,Mint& ABM) ;
    friend void DivideByBaseReven(unsigned long nPrimes,RPrimes* PrimesR,long A,Mint& ABM) ;
    friend void DivideByBaseRodd(unsigned long nPrimes,unsigned long SZLR,RPrimes* PrimesR,long A,Mint& ABM) ;
    friend void DivideByBaseReven(unsigned long nPrimes,unsigned long SZLR,RPrimes* PrimesR,long A,Mint& ABM) ;
    friend void DivideByBaseAodd(unsigned long nPrimesA,unsigned long SZL,APrimes* PrimesA,long A,Mint& norm);
    friend void DivideByBaseAeven(unsigned long nPrimesA,unsigned long SZL,APrimes* PrimesA,long A,Mint& norm);
    friend PolyM power(const PolyM& x,const Mint& n,const PolyM& p,const Mint& N);
friend PolyM power1(const PolyM& x,const Mint& n,const PolyM& p,const Mint& N);


    friend Mint rho(const Mint& N,int nLoop,int c) ;
    friend int Proth(const Mint& N) ;

    friend int SetPrecision(const int _precision) ;
    friend int GetPrecision() ;

    // ʲΥдؿˤơѥ᥿ this Ȱ( this=&a )
    // ƤƤ褤.
    // ¿ɤα黻ȡñȤα黻
public:
public:                                // define arithmetic operations
    Mint& isAdd(const Mint& a,const Mint& b) ;
    Mint& isAdd(const Mint& a,const short n) ;
    Mint& isAdd(const Mint& a,const int n) ;
    Mint& isAdd(const Mint& a,const long n) ;
    Mint& isAddUL(const Mint& a,const unsigned long n) ;

    Mint& isSub(const Mint& a,const Mint& b) ;
    Mint& isSub(const Mint& a,const short n) ;
    Mint& isSub(const Mint& a,const int n) ;
    Mint& isSub(const Mint& a,const long n) ;
    Mint& isSubUL(const Mint& a,const unsigned long n) ;

public:
    Mint& isMul(const Mint& a,const Mint& b) ;
Mint& Toom(const Mint& a,const Mint& b) ;
    Mint& isToom3(Mint& a,Mint& b) ;
    Mint& isToom33(Mint& a,Mint& b) ;
friend Mint Toom3(Mint& a,Mint& b) ;
friend Mint Toom(Mint& a,Mint& b) ;
Mint& isShiftAdd(Mint& a,Mint& b,unsigned long n) ;
Mint& isShiftSub(Mint& a,Mint& b,unsigned long n) ;
    Mint& isMul(const Mint& a,const short n) ;
    Mint& isMul(const Mint& a,const int n) ;
    Mint& isMul(const Mint& a,const long n) ;
    Mint& isMulUL(const Mint& a,const unsigned long n) ;
public:
    Mint& isMul(const Mint& a,const Mint& b,const Mint& N) ;
public:
public:
    Mint& isDiv(const Mint& a,const Mint& b) ;
    Mint& isDiv(const Mint& a,const short n) ;
    Mint& isDiv(const Mint& a,const int n) ;
    Mint& isDiv(const Mint& a,const long n) ;
    Mint& isDivUL(const Mint& a,const unsigned long n) ;
//public:
    Mint& isRem(const Mint& a,const Mint& p,int RemType=SameSignRem) ;
                                // RemType=0 ΤȤ 椬 a
                                // Ʊ;
                                // RemType=1 ΤȤǾ;
                                // RenType=2 ΤȤͺǾ;
    long  isRemL(const long n,int RemType=SameSignRem) const ;
    unsigned long isRemUL(const unsigned long n,
                          int RemType=SameSignRem)
                          const ;


    Mint& isShiftl(const Mint& a,const long n) ; // 2ʿȤƤΥե
    Mint& isShiftr(const Mint& a,const long n) ; // this=&a Ǥ뤳ȤƤ
    Mint& isShift32(const Mint& a,const long n); // 2^32ʿȤƤΥե
public:
    Mint& isSquare(const Mint& a) ;              // a*a
    Mint& isSquare2(const Mint& a) ;                 // a*a

        // Ѥδؿ 
    Mint& isGCD(const Mint& a,const Mint& b) ;
    Mint& isAGCD(const Mint& a,const Mint& b) ;
    Mint& isEGCD(const Mint& a,const Mint& b,Mint& u,Mint& v) ;
    Mint& isInvModp(const Mint& a,const Mint& p) ;

    Mint& isNeg(const Mint& a) ;    // negation
public:

       // comparision <   :  isLess    (-1)
       //             ==  :  isEqual   (0)
       //             >   :  isGreater (1)
    int   compare(const Mint& a) const ;
    int   compare(const long n) const ;
    int   compare(const unsigned long n) const ;
    int   compareUL(const unsigned long n) const ; // compare absolute value with n


public:

    bool  allocate(int size) ;
    bool  reallocate(int size) ;
    long  Put(::ostream& os,long& mdigit) const ;
    int   ndim(void) const ;

    static Format format ;       // output format
public:
    static unsigned long _res ;
public:
    static int Size ;
    static int Precision ;
    static int Karatsuba_digit ;
    static int Square_digit ;
    static int Toom3_digit ;
    static int FFT_digit ;
    static Mint _Mtemp ;           // temporary variables used by member functions
    static Mint _uuMtemp ;
    static Mint _vvMtemp ;
    static Mint _uMtemp ;
    static Mint _vMtemp ;
    static FFT _fft[NUM_OF_FFT_SCHEME] ;       // Fast Fourier Transformation class

} ;

#ifndef _ONLY_MINTDECL_
#  include "MintFunc.hpp"
#endif

// size of digit array
inline int Mint::ndim() const
{
  return nDim&_DIGITS_ ;
}

long ilog2(const Mint& n) ;

// bit length of integer
inline long len(const Mint& n)
{
  return ilog2(n)+1 ;
}

#ifndef __BORLANDC__
inline Mint::operator long double() const
{
  return (double)*this ;
}
#endif

////////////////////////////////////////
//
//  greatest common divisor
//  
//
inline Mint gcd(const Mint& a,const Mint& b)
{
  return Mint::_Mtemp.isGCD(a,b) ;
}

//////////////////////////////////////////
//
// 롥 ͺǾ;ȤäƷ׻.
// 礭ˤƤϡդĤκε 20%®.
//
inline Mint agcd(const Mint& a,const Mint& b)
{
  return Mint::_Mtemp.isAGCD(a,b) ;
}

// extended Eulidean algorithm
inline Mint egcd(const Mint& a,const Mint& b,Mint& u,Mint& v)
{
  return Mint::_uuMtemp.isEGCD(a,b,u,v) ;
}

// for debug
::ostream& component(::ostream& os,const Mint& n) ;

//////////////////////////////////////////////////
//
// sign
// return value   1 : n is Positive
//               -1 : n is Negative
//                0 : n is Zero
//
inline int sign(const Mint& n)
{
  return n.isZero() ? 0:( n.nDim>0 ? 1:-1) ;
}

inline int sgn(const Mint& n)
{
  return sign(n) ;
}

////////////////////////////////////////
//
//  destructor
//
inline Mint::~Mint()
{                          // do nothing rather than freeing heap memory
#ifdef _MEMMAN
  _MemMan.free(digit) ;
#else
  delete [] digit ;
#endif
}


////////////////////////////////////////
//
//  arithmetic operations
//
//
inline Mint& Mint::isAdd(const Mint& a,const short n)
{
  return n<0 ? isSubUL(a,-n):isAddUL(a,n) ;
}

inline Mint& Mint::isAdd(const Mint& a,const int n)
{
  return n<0 ? isSubUL(a,-n):isAddUL(a,n) ;
}

inline Mint& Mint::isAdd(const Mint& a,const long n)
{
  return n<0 ? isSubUL(a,-n):isAddUL(a,n) ;
}

inline Mint& Mint::isSub(const Mint& a,const short n)
{
  return isSub(a,long(n)) ;
}

inline Mint& Mint::isSub(const Mint& a,const int n)
{
  return isSub(a,long(n)) ;
}

inline Mint& Mint::isSub(const Mint& a,const long n)
{
  return n<0 ? isAddUL(a,-n):isSubUL(a,n) ;
}

inline Mint& Mint::isMul(const Mint& a,const short n)
{
  return isMul(a,long(n)) ;
}

inline Mint& Mint::isMul(const Mint& a,const int n)
{
  return isMul(a,long(n)) ;
}

inline Mint& Mint::isMul(const Mint& a,const long n)
{
  return n>=0 ? isMulUL(a,n):~isMulUL(a,-n) ;
}

inline Mint& Mint::isMul(const Mint& a,const Mint& b,const Mint& N)
{
  return  isRem(isMul(a,b),N) ;
}


inline Mint& Mint::isDiv(const Mint& a,const short n)
{
  return isDiv(a,long(n)) ;
}

inline Mint& Mint::isDiv(const Mint& a,const int n)
{
  return isDiv(a,long(n)) ;
}

inline Mint& Mint::isDiv(const Mint& a,const long n)
{
  return n>0 ? isDivUL(a,n):~isDivUL(a,-n) ;
}


///////////////////
//
//  return value   true  : is zero
//                 false : is not zero
//
inline bool Mint::isZero(void) const
{
  return nDigit==0 ;
}

inline bool Mint::isPositive(void) const
{
  return nDigit>0 && nDim>0 ;
}

inline bool Mint::isNegative(void) const
{
  return nDim<0 ;
}


///////////////////////
//
//  return parity
//
inline bool Mint::isEven(void) const
{
  return isZero() || !((bool)(*digit&1)) ;
}

inline bool Mint::isOdd(void) const
{
  return !isZero() && (bool)(*digit&1)  ;
}


inline Format SetFormat(Format form)   // Ϸ
{
  Format nowForm=Mint::format ;
  Mint::format=form ;
  return nowForm ;
}

/////////////////////////
//
//  number of digits
//
inline int Mint::ndigit(void) const
{
  return nDigit ;
}

inline int ndigit(const Mint& n)
{
  return n.ndigit() ;
}

/////////////////////////////
//
//  number of faractional digits
//
inline int Mint::fdigit() const
{
  return fDigit ;
}

inline int fdigit(const Mint& n)
{
  return n.fdigit() ;
}

/////////////////////////////
//
// shift as 2^32 adic integer
//
inline Mint& Mint::operator[](const long s)
{
  return isShift32(*this,s) ;
}

inline Mint Mint::operator()(const long s) const
{
  return _Mtemp.isShift32(*this,s) ;
}

////////////////////////////////////
//
//  negate number  ȿž
//
inline Mint& Mint::operator~()
{
  isZero() ? 1:(nDim<0 ? nDim&=0x01ffffff:nDim|=0xff000000) ;
  return *this ;
}

///////////////
//
// 黻
//
inline bool Mint::operator!()
{
  return isZero() ;
}

/////////////////////////
//
//  negation
//
inline Mint Mint::operator-() const
{
  return _Mtemp.isNeg(*this) ;
}

////////////////////////////////////////////
//
//  conversion   long <- Mint
//
// ¿ long int ˷Ѵ
//  long int 礭, long int 礭
// ݤ.
//
inline Mint::operator long() const
{
  return nDim>0 ? (*digit)&0x7fffffff : -long((*digit)&0x7fffffff) ;
}

////////////////////////////////////////////
//
//  conversion   int <- Mint
//
inline Mint::operator int() const
{
  return int(long(*this)) ;
}

////////////////////////////////////////////
//
//  conversion   unsigned long  <- Mint
//
//  ignore sign
//
inline Mint::operator unsigned long() const
{
  return nDigit ? (*digit):0 ;
}


////////////////////////////////////////////
//
//  assignment
//
inline Mint& Mint::operator=(const short n)
{
  return operator=(long(n)) ;
}

inline Mint& Mint::operator=(const int n)
{
  return operator=(long(n)) ;
}

inline Mint& Mint::operator=(const double& d)
{
  return operator=((long double)d) ;
}


//////////////////////////////////
//
//  shift operator
//
inline Mint& Mint::operator>>=(const int n)
{
  return operator>>=(long(n)) ;
}

inline Mint& Mint::operator>>=(const long n)
{
  return n>0 ? isShiftr(*this,n):isShiftl(*this,-n) ;
}

inline Mint& Mint::operator>>=(const unsigned long n)
{
  return isShiftr(*this,long(n)) ;
}

inline Mint& Mint::operator<<=(const int n)
{
  return operator<<=(long(n)) ;
}

inline Mint& Mint::operator<<=(const long n)
{
  return n>0 ? isShiftl(*this,n):isShiftr(*this,-n) ;
}

inline Mint& Mint::operator<<=(const unsigned long n)
{
  return isShiftl(*this,n) ;
}

inline Mint Mint::operator>>(const int n) const
{
  return operator>>(long(n)) ;
}

inline Mint Mint::operator>>(const long n) const
{
  return n>0 ? _Mtemp.isShiftr(*this,n):_Mtemp.isShiftl(*this,-n) ;
}

inline Mint Mint::operator>>(const unsigned long n) const
{
  return _Mtemp.isShiftr(*this,long(n)) ;
}


inline Mint Mint::operator<<(const int n) const
{
  return operator<<(long(n)) ;
}

inline Mint Mint::operator<<(const long n) const
{
  return n>0 ? _Mtemp.isShiftl(*this,n):_Mtemp.isShiftr(*this,-n) ;
}

inline Mint Mint::operator<<(const unsigned long n) const
{
  return _Mtemp.isShiftl(*this,long(n)) ;
}

////////////////////////////////////////
//
//  Absolute Value  
//

inline Mint abs(const Mint& n)
{
  return n.nDim>0 ? n:(Mint::_Mtemp).isNeg(n) ;
}

///////////////////////////////////////
//
//  Addition ˡ
//

inline Mint operator+(const Mint& n,const Mint& m)
{
  return Mint::_Mtemp.isAdd(n,m) ;
}

inline Mint operator+(const Mint& n,const short m)
{
  return Mint::_Mtemp.isAdd(n,long(m)) ;
}


inline Mint operator+(const Mint& n,const int m)
{
  return Mint::_Mtemp.isAdd(n,long(m)) ;
}

inline Mint operator+(const short n,const Mint& a)
{
  return Mint::_Mtemp.isAdd(a,long(n)) ;
}

inline Mint operator+(const int n,const Mint& a)
{
  return Mint::_Mtemp.isAdd(a,long(n)) ;
}

inline Mint operator+(const Mint& n,const long m)
{
  return Mint::_Mtemp.isAdd(n,m) ;
}

inline Mint operator+(const long n,const Mint& a)
{
  return Mint::_Mtemp.isAdd(a,n) ;
}

inline Mint operator+(const Mint& n,const unsigned long m)
{
  return Mint::_Mtemp.isAddUL(n,m) ;
}

inline Mint operator+(const unsigned long n,const Mint& a)
{
  return Mint::_Mtemp.isAddUL(a,n) ;
}

////////////////////////////////////
//
//  subtraction
//
inline Mint operator-(const Mint& n,const Mint& m)
{
  return Mint::_Mtemp.isSub(n,m) ;
}

inline Mint operator-(const Mint& n,const short m)
{
  return Mint::_Mtemp.isSub(n,long(m)) ;
}

inline Mint operator-(const Mint& n,const int m)
{
  return Mint::_Mtemp.isSub(n,long(m)) ;
}

inline Mint operator-(const short n,const Mint& a)
{
  return ~(Mint::_Mtemp.isSub(a,long(n))) ;   // -(a-n)
}

inline Mint operator-(const int n,const Mint& a)
{
  return ~(Mint::_Mtemp.isSub(a,long(n))) ;   // -(a-n)
}

inline Mint operator-(const Mint& n,const long m)
{
  return Mint::_Mtemp.isSub(n,m) ;
}

inline Mint operator-(const long n,const Mint& a)
{
  return ~(Mint::_Mtemp.isSub(a,n)) ;   // -(a-n)
}

inline Mint operator-(const Mint& n,const unsigned long m)
{
  return Mint::_Mtemp.isSubUL(n,m) ;
}

inline Mint operator-(const unsigned long n,const Mint& a)
{
  return ~(Mint::_Mtemp.isSubUL(a,n)) ;   // -(a-n)
}


////////////////////////////////
//
//  multiplication 軻
//
inline Mint operator*(const Mint& n,const Mint& m)
{
  return Mint::_Mtemp.isMul(n,m) ;
}

inline Mint operator*(const Mint& n,const short m)
{
  return Mint::_Mtemp.isMul(n,long(m)) ;
}

inline Mint operator*(const Mint& n,const int m)
{
  return Mint::_Mtemp.isMul(n,long(m)) ;
}

inline Mint operator*(const short n,const Mint& a)
{
  return Mint::_Mtemp.isMul(a,long(n)) ;
}

inline Mint operator*(const int n,const Mint& a)
{
  return Mint::_Mtemp.isMul(a,long(n)) ;
}

inline Mint operator*(const Mint& n,const long m)
{
  return Mint::_Mtemp.isMul(n,m) ;
}

inline Mint operator*(const long n,const Mint& a)
{
  return Mint::_Mtemp.isMul(a,n) ;
}

inline Mint operator*(const Mint& n,const unsigned long m)
{
  return Mint::_Mtemp.isMulUL(n,m) ;
}

inline Mint operator*(const unsigned long n,const Mint& a)
{
  return Mint::_Mtemp.isMulUL(a,n) ;
}

////////////////////////////////////////
//
//  division 
//
inline Mint operator/(const Mint& n,const Mint& m)
{
  return Mint::_Mtemp.isDiv(n,m) ;
}

inline Mint operator/(const Mint& m,const short n)
{
  return Mint::_Mtemp.isDiv(m,long(n)) ;
}

inline Mint operator/(const Mint& n,const int d)
{
  return Mint::_Mtemp.isDiv(n,long(d)) ;
}

inline Mint operator/(const Mint& n,const long d)
{
  return Mint::_Mtemp.isDiv(n,long(d)) ;
}

inline Mint operator/(const Mint& n,const unsigned long d)
{
  return Mint::_Mtemp.isDivUL(n,d) ;
}

////////////////////////////////////////
//
//  residue ;
//
inline Mint Mint::operator%(const Mint& n) const
{
  return _Mtemp.isRem(*this,n) ;
}
                    // δؿͤϡMint Ǥʤ long
inline long Mint::operator%(const short n) const
{
  return isRemL(long(n)) ;
}

inline long Mint::operator%(const int n) const
{
  return isRemL(long(n)) ;
}

inline long Mint::operator%(const long n) const
{
  return isRemL(n) ;
}


inline Mint Mint::operator%(const unsigned long n) const
{
  return (_Mtemp=*this)%=n ;
}


////////////////////////////
//
//  least positive residue
//
inline Mint Mint::operator&(const Mint& n) const
{
  return _Mtemp.isRem(*this,n,PositiveRem) ;
}


inline long Mint:: operator&(const short n) const
{
  return isRemL(long(n),PositiveRem) ;
}

inline long Mint:: operator&(const int n) const
{
  return isRemL(long(n),PositiveRem) ;
}

inline long Mint::operator&(const long n) const
{
  return isRemL(n,PositiveRem) ;
}

inline Mint Mint::operator^(const Mint& n) const
{
  return _Mtemp.isRem(*this,n,AbsoluteRem) ;
}

////////////////////////////
//
//  the least absolute residue
//
inline long Mint:: operator^(const short n) const
{
  return isRemL(long(n),AbsoluteRem) ;
}
                    // δؿͤϡMint Ǥʤ long
inline long Mint:: operator^(const int n) const
{
  return isRemL(long(n),AbsoluteRem) ;
}

inline long Mint::operator^(const long n) const
{
  return isRemL(n,AbsoluteRem) ;
}

inline Mint Mint::operator^(const unsigned long n) const
{
  return _Mtemp.isRem(*this,_uMtemp=n,AbsoluteRem) ;
}


inline unsigned long Mint::operator&(const unsigned long n) const
{
  return isRemUL(n,PositiveRem) ;
}

inline Mint mod(const Mint& n,const Mint& p)
{
  return Mint::_Mtemp.isRem(n,p,PositiveRem) ;
}

inline Mint amod(const Mint& n,const Mint& p)
{
  return Mint::_Mtemp.isRem(n,p,AbsoluteRem) ;
}

inline short mod(const Mint& n,const short p)
{
  return (short)n.isRemL(long(p),PositiveRem) ;
}

inline int mod(const Mint& n,const int p)
{
  return (int)n.isRemL(long(p),PositiveRem) ;
}

inline short amod(const Mint& n,const short p)
{
  return (short)n.isRemL(long(p),AbsoluteRem) ;
}

inline int amod(const Mint& n,const int p)
{
  return (int)n.isRemL(long(p),AbsoluteRem) ;
}

inline long mod(const Mint& n,const long p)
{
  return n.isRemL(p) ;
}


inline long amod(const Mint& n,const long p)
{
  return n.isRemL(long(p),AbsoluteRem) ;
}

inline unsigned long mod(const Mint& n,const unsigned long p)
{
  return n.isRemUL(p,PositiveRem) ;
}

inline Mint amod(const Mint& n,const unsigned long p)
{
 return Mint::_Mtemp.isRem(n,Mint::_uMtemp=p,AbsoluteRem) ;
}

////////////
//
//
//
inline Mint& Mint::operator+=(const Mint& n)
{
  return isAdd(*this,n) ;
}

inline Mint& Mint::operator+=(const short n)
{
  return isAdd(*this,long(n)) ;
}

inline Mint& Mint::operator+=(const int n)
{
  return isAdd(*this,long(n)) ;
}

inline Mint& Mint::operator+=(const long n)
{
  return isAdd(*this,n) ;
}

inline Mint& Mint::operator+=(const unsigned long n)
{
  return isAddUL(*this,n) ;
}

inline Mint& Mint::operator-=(const Mint& n)
{
  return isSub(*this,n) ;
}

inline Mint& Mint::operator-=(const short n)
{
  return isSub(*this,long(n)) ;
}

inline Mint& Mint::operator-=(const int n)
{
  return isSub(*this,long(n)) ;
}

inline Mint& Mint::operator-=(const long n)
{
  return isSub(*this,n) ;
}

inline Mint& Mint::operator-=(const unsigned long n)
{
  return isSubUL(*this,n) ;
}

inline Mint& Mint::operator*=(const Mint& n)
{
  return isMul(*this,n) ;
}

inline Mint& Mint::operator*=(const short n)
{
  return operator*=(long(n)) ;
}

inline Mint& Mint::operator*=(const int n)
{
  return operator*=(long(n)) ;
}

inline Mint& Mint::operator*=(const long n)
{
  return isMul(*this,n) ;
}

inline Mint& Mint::operator*=(const unsigned long n)
{
  return isMulUL(*this,n) ;
}

inline Mint& Mint::operator/=(const Mint& n)
{
  return isDiv(*this,n) ;
}

inline Mint& Mint::operator/=(const short n)
{
  return isDiv(*this,long(n)) ;
}

inline Mint& Mint::operator/=(const int n)
{
  return isDiv(*this,long(n)) ;
}

inline Mint& Mint::operator/=(const long n)
{
  return isDiv(*this,n) ;
}

inline Mint& Mint::operator/=(const unsigned long n)
{
  return isDivUL(*this,n) ;
}

inline Mint& Mint::operator%=(const Mint& n)
{
  return isRem(*this,n) ;
}

inline Mint& Mint::operator&=(const Mint& n)
{
  return isRem(*this,n,PositiveRem) ;
}

inline Mint& Mint::operator^=(const Mint& n)
{
  return isRem(*this,n,AbsoluteRem) ;
}

inline Mint& Mint::operator%=(const short n)
{
  return *this %= long(n) ;
}

inline Mint& Mint::operator%=(const int n)
{
  return *this %= long(n) ;
}

inline Mint& Mint::operator&=(const short n)
{
  return *this &= long(n) ;
}

inline Mint& Mint::operator&=(const int n)
{
  return *this &= long(n) ;
}

inline Mint& Mint::operator^=(const short n)
{
  return *this=isRemL(long(n),AbsoluteRem) ;
}

inline Mint& Mint::operator^=(const int n)
{
  return *this=isRemL(long(n),AbsoluteRem) ;
}

inline Mint& Mint::operator%=(const long n)
{
  return *this=isRemL(n) ;
}

inline Mint& Mint::operator&=(const long n)
{
  return *this=isRemL(n,PositiveRem) ;
}

inline Mint& Mint::operator^=(const long n)
{
  return *this=isRemL(n,AbsoluteRem) ;
}

inline Mint& Mint::operator&=(const unsigned long n)
{
  return *this=isRemUL(n,PositiveRem) ;
}

inline Mint& Mint::operator^=(const unsigned long n)
{
  return isRem(*this,_uMtemp=n,AbsoluteRem) ;
}

///////////////////////////////
//
// inverse of a modulo p
//
inline Mint invmodp(const Mint& a,const Mint& p)
{
  return Mint::_Mtemp.isInvModp(a,p) ;
}

//inline unsigned long invmodp(const Mint& a,const unsigned long p)
//{
//  return invmodp(mod(a,p),p) ;
//}


inline Mint Mint::operator+() const
{
  return *this ;
}

///////////////////////////////////////
//
//  increment,decrement
//
inline Mint& Mint::operator++()       // ++x
{
  return isAddUL(*this,1) ;
}

inline Mint  Mint::operator++(int)    // x++
{
  _Mtemp=*this ;
  isAddUL(*this,1) ;
  return _Mtemp ;
}

inline Mint& Mint::operator--()       // --x
{
  return isSubUL(*this,1) ;
}

inline Mint  Mint::operator--(int)    // x--
{
  _Mtemp=*this ;
  isSubUL(*this,1) ;
  return _Mtemp ;
}


///////////////////////////////
//
//  comparison
//  
//
inline int Mint::compare(const unsigned long n) const
{
  return nDim>0 ? compareUL(n):isLess ;
}

inline bool Mint::operator==(const Mint& a) const
{
  return compare(a)==isEqual ;
}

inline bool Mint::operator==(const short n) const
{
  return compare(long(n))==isEqual ;
}

inline bool Mint::operator==(const int n) const
{
  return compare(long(n))==isEqual ;
}

inline bool operator==(const short n,const Mint& a)
{
  return a==long(n) ;
}

inline bool operator==(const int n,const Mint& a)
{
  return a==long(n) ;
}

inline bool Mint::operator==(const long n) const
{
  return compare(n)==isEqual ;
}

inline bool operator==(const long n,const Mint& a)
{
  return a==n ;
}

inline bool Mint::operator==(const unsigned long n) const
{
  return compare(n)==isEqual ;
}

inline bool operator==(const unsigned long n,const Mint& a)
{
  return a==n ;
}

inline bool Mint::operator!=(const Mint& b) const
{
  return !(operator==(b) ) ;
}

inline bool Mint::operator!=(const short b) const
{
  return compare(long(b))!=isEqual ;
}

inline bool Mint::operator!=(const int b) const
{
  return compare(long(b))!=isEqual ;
}

inline bool operator!=(const short n,const Mint& a)
{
  return a!=long(n) ;
}

inline bool operator!=(const int n,const Mint& a)
{
  return a!=long(n) ;
}

inline bool Mint::operator!=(const long b) const
{
  return compare(b)!=isEqual ;
}

inline bool operator!=(const long n,const Mint& a)
{
  return a!=n ;
}

inline bool Mint::operator!=(const unsigned long b) const
{
  return compare(b)!=isEqual ;
}

inline bool operator!=(const unsigned long n,const Mint& a)
{
  return a!=n ;
}

inline bool Mint::operator>(const Mint& a) const
{
  return compare(a)==isGreater ;
}

inline bool Mint::operator>(const short n) const
{
  return compare(long(n))==isGreater ;
}

inline bool Mint::operator>(const int n) const
{
  return compare(long(n))==isGreater ;
}

inline bool operator>(const short n,const Mint& a)
{
  return a.operator<(long(n)) ;
}

inline bool operator>(const int n,const Mint& a)
{
  return a.operator<(long(n)) ;
}

inline bool Mint::operator>(const long n) const
{
  return compare(n)==isGreater ;
}

inline bool operator>(const long n,const Mint& a)
{
  return a.operator<(n) ;
}

inline bool Mint::operator>(const unsigned long n) const
{
  return compare(n)==isGreater ;
}

inline bool operator>(const unsigned long n,const Mint& a)
{
  return a.operator<(n) ;
}

inline bool Mint::operator<(const Mint& a) const
{
  return compare(const_cast<Mint&>(a))==isLess ;
}


inline bool Mint::operator<(const short n) const
{
  return compare(long(n))==isLess ;
}

inline bool Mint::operator<(const int n) const
{
  return compare(long(n))==isLess ;
}

inline bool operator<(const short n,const Mint& a)
{
  return a.operator>(long(n)) ;
}

inline bool operator<(const int n,const Mint& a)
{
  return a.operator>(long(n)) ;
}

inline bool Mint::operator<(const long n) const
{
  return compare(n)==isLess ;
}

inline bool operator<(const long n,const Mint& a)
{
  return a.operator>(n) ;
}

inline bool Mint::operator<(const unsigned long n) const
{
  return compare(n)==isLess ;
}

inline bool operator<(const unsigned long n,const Mint& a)
{
  return a.operator>(n) ;
}

inline bool Mint::operator>=(const Mint& a) const
{
  return compare(a) != isLess ;
}

inline bool Mint::operator>=(const short n) const
{
  return  compare(long(n))!=isLess ;
}

inline bool Mint::operator>=(const int n) const
{
  return  compare(long(n))!=isLess ;
}

inline bool operator>=(const short n,const Mint& a)
{
  return a.operator<=(long(n)) ;
}

inline bool operator>=(const int n,const Mint& a)
{
  return a.operator<=(long(n)) ;
}

inline bool Mint::operator>=(const long n) const
{
  return  compare(n)!=isLess ;
}

inline bool operator>=(const long n,const Mint& a)
{
  return a.operator<=(n) ;
}

inline bool Mint::operator>=(const unsigned long n) const
{
  return  compare(n)!=isLess ;
}

inline bool operator>=(const unsigned long n,const Mint& a)
{
  return a.operator<=(n) ;
}

inline bool Mint::operator<=(const Mint& a) const
{
  return !(compare(a)==isGreater ) ;
}

inline bool Mint::operator<=(const short n) const
{
  return compare(long(n))!=isGreater ;
}

inline bool Mint::operator<=(const int n) const
{
  return compare(long(n))!=isGreater ;
}

inline bool operator<=(const short n,const Mint& a)
{
  return a.operator>=(long(n)) ;
}

inline bool operator<=(const int n,const Mint& a)
{
  return a.operator>=(long(n)) ;
}

inline bool Mint::operator<=(const long n) const
{
  return compare(n)!=isGreater ;
}

inline bool operator<=(const long n,const Mint& a)
{
  return a.operator>=(n) ;
}

inline bool Mint::operator<=(const unsigned long n) const
{
  return compare(n)!=isGreater ;
}

inline bool operator<=(const unsigned long n,const Mint& a)
{
  return a.operator>=(n) ;
}

//
//  compute a+b[n]
//  must be &a!=&b
inline Mint& Mint::isShiftAdd(Mint& a,Mint& b,unsigned long n)
{
    a.fDigit=n ;
    isAdd(a,b) ;
    a.fDigit=0 ;
    fDigit=0 ;
    return *this ;
}

//  compute a-b[n]
//  must be &a!=&b
inline Mint& Mint::isShiftSub(Mint& a,Mint& b,unsigned long n)
{
    a.fDigit=n ;
    isSub(a,b) ;
    a.fDigit=0 ;
    fDigit=0 ;
    return *this ;
}
#endif


