#include <stdlib.h>
#define SNFS
#include <vector>
#include "bvector.hpp"
#include "Mint.hpp"
#include "Fint.hpp"
#include "TBit.hpp"
#include "Dbl.hpp"
#include "Complex.hpp"
#include "FFT.hpp"
#include "Hash.hpp"
#include "Mont.hpp"
#include "SMatrix.hpp"
#include "Lanczos.hpp" 
#include "PPMPQS.hpp"
using namespace std ;
void SieveShift(unsigned long nPrimes,
	PPrimes* Primes,
	unsigned long* Bmodp,
	long sign,Mint& a,Mint& b) ;
void SieveInit(unsigned long ncomb,unsigned long nPrimes,
	PPrimes* Primes,unsigned long* Bmodp,Mint& b,Mint& c) ;
void DivideByBase(unsigned long SZR,PPrimes* Primes) ;
void SetTable(Mint & a,unsigned long ncomb,unsigned long* Bmodp[],
	unsigned long nPrimes,PPrimes* Primes) ;
void SieveShiftm(unsigned long nPrimes,
	PPrimes* Primes,unsigned long* Bmodp) ;
void SieveShift(unsigned long nPrimes,
	PPrimes* Primes,unsigned long* Bmodp,long sign) ;
void Sieve(PPrimes* Primes,
	unsigned long,unsigned long,unsigned long) ;
void SieveDone(unsigned long ua,
		PPrimes* Primes) ;
unsigned long Gauss(unsigned long,
			unsigned long,
			unsigned long,
			unsigned long**,
			unsigned long**) ;
unsigned long Select_S_W(unsigned long&,unsigned long*,unsigned long*) ;

int main(void)
{
    Mint a,b,c,d ;
    Fint fa,fb,fc,fd ;
    unsigned long ua,ub,uc,ud;
    long la,lb,lc,ld ;
    double dd,da ;
    TBit ba,bb,bc,bd ;
    Dbl dbl ;
    Complex ca,cb,cc,cd ;
    FFT fft ;
    Hash hash ;
    unsigned long* uary[10] ;
    SparseMatrix smat ;
    PPrimes Primes ;
    Fint f;


    Mont mont,monta,montb,montc,montd ;

    SieveShift(ua,&Primes,&ua,la,a,a) ;
    SieveInit(ua,ua,&Primes,&ua,a,a) ;
    DivideByBase(ua,&Primes) ;
    SetTable(a,ua,uary,ua,&Primes) ;
    Sieve(&Primes,ua,ua,ua) ;
    SieveShiftm(ua,&Primes,&ua) ;
    SieveDone(ua,&Primes) ;
    SieveShift(ua,&Primes,&ua,la) ;
    Lanczos lz(10,10) ;
    std::vector<unsigned long*> vecul ;
    lz.Solve(vecul) ;
    Gauss(ua,ua,ua,uary,uary) ;
    Select_S_W(ua,&ua,&ua) ;
    block_vector bv(32) ;
    block_vector cv(bv) ;
    ua=bv*ua ;
    bv.isAND(bv,ua) ;
    cv=bv ;
    bv.isAdd(bv,bv) ;
    bv.isMul(bv,bv) ;
    bv.isMulT(smat,bv) ;
    bv.isMul(smat,bv) ;
    bv.isZero() ;
    bv.isIpro(bv,bv) ;
    Swap(bv,bv) ;
//@Fint@isSquare$qrx4Fint
//   ;
//   ;  Fint& Fint::isSquare(const Fint& a)
    fa.isSquare(fb) ;

//@Fint@isRound$qrx4Fintxi
//   ;
//   ;  Fint& Fint::isRound(const Fint& a,const int n)
    fa.isRound(fb,int(10)) ;


//@Mint@$brmod$qxul
//   ;
//   ;  Mint& Mintoperator%=(const unsigned long n)
    a%=ua ;

//@QSortULA$qxlxt1xt1pul
//   ;
//   ;  void QSortULA(const long _size,const long _length,const long pos,unsigned long* record)
    QSortULA(ua,ua,la,&ua) ;
//@prmdiv$qrx4Mintxul
//   ;
//   ;  unsigned long prmdiv(const Mint& n,const unsigned long MAX_DIVISOR)
    prmdiv(a,ua) ;

//@prm$qxul
//   ;
//   ;  unsigned long prm(const unsigned long n)
    prm(ua) ;


//@invmodp$qxlxt1
//   ;
//   ;  long invmodp(const long a,const long p)
    invmodp(la,lb) ;


//@Gauss$qulululppult4
//   ;
//   ;  unsigned long Gauss(unsigned long nBit1,unsigned long nBit2,
//   ;                                          unsigned long nRow,
  // ;                                          unsigned long** Z1,unsigned long** Z2)
 //  ;  {
    unsigned long* Z1 ;
//    Gauss(ua,ua,ua,&Z1,&Z2) ;

//@divide$qllrlt3
//   ;
//   ;  void divide(long a,long b,long& q,long& r)
    divide(la,lb,lc,ld) ;

//@TBit@$brxor$qrx4TBit
//   ;
//   ;  TBit& TBit::operator^=(const TBit& b)
    ba.operator^=(bc) ;

    prmdiv(a,12000UL) ;
    prm(ua) ;
    fa.compare(a) ;
//    a=_small_primes_[0] ;
    f=Fint::_vFtemp ;
    c.isAdd(a,b) ;
    uc=isAdd(ua,ub,ub) ;
    uc=isSub(ua,ub,ub) ;
    b.isAddUL(a,ua) ;
    lc=amod(la,lb) ;
    lc=amod(ua,ub) ;  //long amod(const unsigned long a,const unsigned long b)
    c.isAND(a,b);                  // Mint& Mint::isAND(const Mint& a,const Mint& b)

    d.apower(a,b,c);       //Mint& Mint::apower(const Mint& x,const Mint& n,const Mint& p)
    fa.operator=(a) ;                  // Fint& Fint::operator=(const Mint& a)

//    fa.operator=(dd) ;  // Fint& Fint::operator=(const double& d)


    dd=double(fa) ;     //Fint::operator double() const
    d.operator=(la) ;               // Mint& Mint::operator=(const long n)
    d.operator=(a) ;                 // Mint& Mint::operator=(const Mint& a)


    d.operator=(ua) ;         //                Mint& Mint::operator=(const unsigned long n)



    bd.operator&=(ba) ;   // TBit& TBit::operator&=(const TBit& b)

    BitIndex(&ua,(long)1); // bool BitIndex(const unsigned long* bit,const long index)
    BitOff(&ua,long(1)) ; // void BitOff(const unsigned long* bit,const long index)
    BitOn(&ua,long(1)) ; //  void BitOn(const unsigned long* bit,const long index)
    bd.operator|=(ba) ;    // TBit& TBit::operator|=(const TBit& b)
    BitReverse(&ua,long(1)) ;         // void BitReverse(const unsigned long* bit,const long index)
    BitScanForward(&ua,long(32));    // long BitScanForward(const unsigned long* bit,const long nArray)
    BitScanReverse(&ua,long(32));    // long BitScanReverse(const unsigned long* bit,const long nArray)
    xchg(ba,bb) ;                  // void xchg(TBit& a,TBit& b)
    fa.compare(fb) ;         // int Fint::compare(const Mint& n) const
    a.compare(b);                // int Mint::compare(const Mint& a) const
    fa.compareL(long(1)) ;      // int Fint::compareL(const long n) const
    fa.compareUL((unsigned long)1);   // int Fint::compareUL(const unsigned long n) const
    a.compare(long(1)) ;   //int Mint::compare(const long n) const
    a.compareUL((unsigned long)1) ;     // int Mint::compareUL(const unsigned long n) const
//    da=(double)a ;        // Mint::operator double() const
    dbl.Sign() ;    //int Dbl::Sign(void)                     // return signature
    dbl.Exp() ;             //int Dbl::Exp(void)                      // return exponent

    dbl.Low() ;     //unsigned long Dbl::Low()      // return digits
    dbl.High() ;     // unsigned long Dbl::High()     // ͭ  32ӥå
    dbl.SetHigh(10) ;  //  void Dbl::SetHigh(unsigned long d)
    dbl.SetLow(10) ;    // void Dbl::SetLow(unsigned long d)
    dbl.SetSign(1) ;// void Dbl::SetSign(int s)      // 򥻥å
    dbl.SetExp(10) ; // void Dbl::SetExp(int e)
    dbl.isZero() ;   // bool Dbl::isZero()
    dbl.isPositiveInfinity() ; // bool Dbl::isPositiveInfinity()
    dbl.isNegativeInfinity() ;  // bool Dbl::isNegativeInfinity()
    dbl.isIndefinite() ;       // bool Dbl::isIndefinite()
    dbl.isDeNormal() ;         // bool Dbl::isDeNormal()
------

    fa.isDivF(a,b) ;        // Fint& Fint::isDivF(const Mint& a,const Mint& b)
//    cd.isDivF(a,ca) ;         // Complex& Complex::isDivF(const Mint& s,const Complex& c)
    divide(la,lb,lc,ld) ;    // void divide(long a,long b,long& q,long& r)
    divide(a,b,c,d) ;          // void divide(const Mint& a,const Mint& b,Mint& q,Mint& r)
    divide(ua,ub,uc,ud) ;                 // void divide(const unsigned long a,const unsigned long b,
                        // unsigned long& q,unsigned long& r)
    c.isDiv(a,b) ;                    // Mint& Mint::isDiv(const Mint& a,const Mint& b)
    c.isDivUL(a,ua) ;       // Mint& Mint::isDivUL(const Mint& a,const unsigned long n)
    egcd(la,lb,lc,ld) ;  // long egcd(const long u,const long v,long& u1,long& u2)
    eulerphi(ua) ;                   // unsigned long eulerphi(const unsigned long n)
    fft.fft(&ua,ub,&uc) ;              // void FFT::fft(unsigned long* data,unsigned long prime,unsigned long* roots)
    fft.ifft(&ua,ub,&uc) ;               // void FFT::ifft(unsigned long* data,unsigned long prime,unsigned long* roots)
    fft.initialize((unsigned long)24) ; // bool FFT::initialize(unsigned long nsize)
    fft.fft_mul(a,b,c) ;   // void FFT::fft_mul(const Mint& x,const Mint& y,Mint& xy)
    frandom(ua) ;       //                 float frandom(unsigned long& Xn)
    drandom(ua) ;         // double drandom(unsigned long& Xn)
    unsigned long* M ;
    Gauss(&M,la,lb,lc,&ub) ;
    // void Gauss(unsigned long** M,long nrow,long ncol,long BitSize,unsigned long* ipiv)
    gcd(la,lb) ;         // long gcd(const long a,const long b)
    gcd(ua,ub) ;        // unsigned long gcd(const unsigned long a,const unsigned long b)

    hash.set(ua) ; // void Hash::set(const unsigned long key)
    hash.dec(ua) ; //void Hash::dec(const unsigned long key)
    hash.remove(ua) ;     // void Hash::remove(const unsigned long key)
    hash.result(ua) ;   // unsigned long Hash::result(const unsigned long key)
    hash.key(ua) ;          // unsigned long Hash::key(const unsigned long key)
    ilog2(a) ;                    // long ilog2(const Mint& n)
    a=Int(fa) ;   // Mint Int(const Fint& f)
    fa=inverse(a) ; //  Fint inverse(const Mint& a)
    fa.isInverse(fb) ;  // Fint& Fint::isInverse(const Fint& a)
    invmodp(la,lb) ;          // long invmodp(const long a,const long p)
    invmodp(ua,ub) ;           // unsigned long invmodp(const unsigned long a,const unsigned long p)
    irandom(ua) ;                // unsigned long irandom(unsigned long& Xn)
    isqrt(ua,ub) ;             // unsigned long isqrt(const unsigned long n0,const unsigned long n1)
    a.isRem2(b,long(10)) ;         // Mint& Mint::isRem2(const Mint& a,const long s /* ,int RemType */)
    la=Kronecker(lb,lc) ;         // long Kronecker(const long a,const long b)
    la=Kronecker(ub,uc) ;        // long Kronecker(const unsigned long a,const unsigned long b)
    Mint mm(a) ;            // Mint::Mint(const Mint& a)          // copy constructor
    la=mod(lb,lc) ;       // long mod(const long n,const long p)
    ua=mod(ub,uc) ;       // unsigned long mod(const long a,const unsigned long p)
    mont.SetModulus(a) ;// bool Mont::SetModulus(const Mint& N)
    mont.reduce(a) ;                    // Mont&  Mont::reduce(const Mint& x)
    montc.isAdd(monta,montb) ;                    // Mont& Mont::isAdd(const Mont& x,const Mont& y)
    montc.isSub(monta,montb) ; // Mont& Mont::isSub(const Mont& x,const Mont& y)
    montc.power(monta,a) ;                          // Mont& Mont::power(const Mont& x,const Mint& n)
    fa.isMulF(fb,fc) ;        // Fint& Fint::isMulF(const Mint& a,const Mint& b)
    a.isMul(b,c) ; // Mint& Mint::isMul(const Mint& a,const Mint& b)
    la=mod(lb,lc,ld) ;               // long mod(const long a,const long b,const long m)
    ua=mod(ub,uc,ud) ; // unsigned long mod(const unsigned long a,const unsigned long b,
                       //  const unsigned long m)
    a.isMulUL(b,ua) ;   // Mint& Mint::isMulUL(const Mint& a,const unsigned long n)
    b.isNeg(a) ;            // Mint& Mint::isNeg(const Mint& a)
    ua=nextprm(ub) ;    //unsigned long nextprm(const unsigned long n)
    a.isOR(a,b) ;                    // Mint& Mint::isOR(const Mint& a,const Mint& b)
    PrimeDecomp(ua,&ub,&uc,a) ;   // int PrimeDecomp(unsigned long nPrimes,unsigned long* Primes,
                // unsigned long* index,Mint& q)
    power(la,ua,lb) ;    // long power(const long x,const unsigned long n,const long p)
    power(ua,ub,uc) ;   //unsigned long power(const unsigned long x,const unsigned long n,
                    // const unsigned long p)
//    prmdiv(a,1000UL) ; //unsigned long prmdiv(const Mint& n,const unsigned long MAX_DIVISOR)
    prmdiv2(ua,ub,1000UL) ;
            // unsigned long prmdiv2(const unsigned long n1,const unsigned long n0,const unsigned long MAX_DIVISOR)
    prmdiv(ua) ;    // unsigned long prmdiv(const unsigned long n)

    prmroot(ua) ;            // unsigned long prmroot(const unsigned long p)
    prmrootp(ua) ;             // unsigned long prmrootp(const unsigned long p)
    QSortL2A(la,la,la,la,&la) ;
//void QSortL2A(const long _size,const long _length,
//              const long pos1,const long pos2,long* record)
    QSortLA(la,la,
    la,&la) ;
//void QSortLA(const long _size,const long _length,const long pos,long* record)
    QSortLD(la,la,la,&la) ;
    //void QSortLD(const long _size,const long _length,const long pos,long* record)
    QSortUL2A(ua,ua,ua,ua,&ua) ;
//void QSortUL2A(const long _size,const long _length,
//              const long pos1,const long pos2,unsigned long* record)

    QSortUL2A(ua,ua,
    ua,ua,
    &ua) ;
    //void QSortUL4A(const long _size,const long _length,
    //            const long pos1,const long pos2,const long pos3,const long pos4,
    //            unsigned long* record)
    QSortUL4A(ua,ua,
    ua,ua,ua,ua,
    &ua) ;
    QSortULA(ua,ua,
    ua,&ua) ;
    //void QSortULA(const long _size,const long _length,const long pos,unsigned long* record)
    QSortULD(ua,ua,ua,&ua) ;
    //void QSortULD(const long _size,const long _length,const long pos,unsigned long* record)
    QSortUSA(ua,ua,ua,(unsigned short*)&ua) ;
    //void QSortUSA(const long _size,const long _length,const long pos,unsigned short* record)
    QSortUSD(ua,ua,ua,(unsigned short*)&ua) ;
    //void QSortUSD(const long _size,const long _length,const long pos,unsigned short* record)


    a.isRem(a,b) ;
    //Mint& Mint::isRem(const Mint& a,const Mint& b,int RemType)

    a.isRemUL(a,10UL) ;
//unsigned long Mint::isRemUL(const unsigned long n,int RemType) const
    fa.isSqrt(fb) ;     //  Fint& Fint::isSqrt(const Fint& a)
    la=sqrt(lb,lc) ;    // long sqrt(const long a,const long p)
    ua=sqrt(ub,uc) ;   //unsigned long sqrt(const unsigned long a,const unsigned long p)
    c.isSquare(a) ;         // Mint& Mint::isSquare(const Mint& a)
    fc.isSquare(fa) ;       // Fint& Fint::isSquare(const Fint& a)
    searchTable_byValue(ua) ;          // long searchTable_byValue(const unsigned long value)
    c.isSub(a,b) ;                   // Mint& Mint::isSub(const Mint& a,const Mint& b)
    a.isSubUL(a,(unsigned long)10);  // Mint& Mint::isSubUL(const Mint& a,const unsigned long n)
    Swap(a,b) ;                               // void Swap(Mint& a,Mint& b)
    ba.operator=(bb) ;    // TBit& TBit::operator=(const TBit& b)
    a.isXOR(b,c) ;                      // Mint& Mint::isXOR(const Mint& a,const Mint& b)


}
