//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  return factorial n!=1*2*...*n  for n>=0
//

#include "Mint.hpp"

#if 0       // this is old version
Mint old_factorial(unsigned long n)
{
  Mint f(1) ;
  while( n ) {
    f*=n ;
    n-- ;
  }
  return f ;
}


#endif

//
//   compute b!/a!   (a<=b)
//   x! = pfactorial(0,x)
//
//  ʬˡˤäƷ׻
//
#if 0
Mint& Mint::pfactorial(unsigned long a,unsigned long b,unsigned long ndiv)
{
    if( b-a>ndiv ) {
        unsigned long ab=(a+b)>>1 ;
        Mint f1(0),f2(0) ;

        return isMul(f1.pfactorial(a,ab,ndiv),f2.pfactorial(ab,b,ndiv)) ;
    }
    else {
        allocate(ndiv+1) ;
        *this=1 ;
        for( a++ ; a<=b ; a++ ) (*this)*=a ;
        return *this ;
    }
}
#endif

Mint pfactorial(unsigned long a,unsigned long b,unsigned long ndiv)
{
    if( b-a>ndiv ) {
        unsigned long ab=(a+b)>>1 ;
//      unsigned long ab=a+ndiv ;
        return pfactorial(a,ab,ndiv)*pfactorial(ab,b,ndiv) ;
    }
    else {
        Mint f(ndiv,0) ;
        f=1 ;
        for( a++ ; a<=b ; a++ ) f*=a ;
        return f ;
    }
}

// Q(a,b) = b(b-1)..(a+2)+b(b-1)..(a+3)+..+b(b-1) + b +1
Mint qfactorial(unsigned long a,unsigned long b,unsigned long ndiv)
{
    if( b-a>ndiv ) {
        unsigned long ab=(a+b)>>1 ;
        return qfactorial(a,ab,ndiv)*pfactorial(ab,b,ndiv)
                + qfactorial(ab,b,ndiv) ;
    }
    else {
        Mint f(ndiv,0) ;
        f=0 ;
        for( a++ ;  a<=b ; a++ ) {
            ++f ;
            f*=a ;
        }
        return f ;
    }
}
