//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  Moebius function
//  return valuse :  0      n contains a square
//                  (-1)^s  n is squarefree with prime factorization
//                          n=P_1P_2...P_s
//
#include "IntFuncs.hpp"

int Moebius(unsigned long n)
{
  unsigned long p(0),q ;
  int k(1) ;
  if( n==1 ) return k ;       // add case n=1  98/05/25
  for(;;) {
    q=prmdiv(n) ;
    if( q==1 ) {
      if( n==p ) return 0 ;   // p is a prime divisor
      k=-k ;
      break ;
    }
    else {
      if( p==q ) return 0 ;  // p is the last prime divisor
      else {
        p=q ;
        k=-k ;
      }
    }
    n/=q ;

  }
  return k ;
}
