//
//  Copyright (C) by S.Tomabechi 2000
//  All rights reserved.
//
//  return the nearest integer for a given real number
//
#include "Fint.hpp"

Mint nearInt(const Fint& f)
{
  long s=sign(f) ;

  if( s==0 ) return Mint(0) ;           // f = 0
  else {
    Mint If=Int(f) ;
    if( f.fDigit<=f.nDigit ) {
        if( f.digit[f.fDigit-1]>=0x80000000 ) {   // 0.5<= f < 1
            return If+s ;
        }
        else return If ;                       // less than 0.5
    }
    else return If ;
  }

}


#if 0
int main(void)
{
  SetPrecision(10) ;
  Fint f,g,h ;
  f=1 ;
  g=1 ;
  g>>=1 ;
  h=f+g ;
  cout << endl << h << " " << nearInt(h) ;
  h=-h ;
  cout << endl << h << " " << nearInt(h) ;


  h=f+g ;
//  h[-2] ;
  h/=100 ;
  cout << endl << h << " " << nearInt(h) ;

  g>>=100 ;
  h=g ;
  cout << endl << h << " " << nearInt(h) ;
  h=-g ;
  cout << endl << h << " " << nearInt(h) ;

}
#endif
