//
//  Copyright (c) 1993.1994,1995  by S.Tomabechi
//     All rights reserved.
//
//  residue modulo signed integer
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Mint
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "Error.hpp"

long Mint::isRemL(const long n,int RemType) const
{
  if( n==0 ) Error(zero divide) ;

  __asm {
    mov   edi,this
#ifdef __BORLANDC__
    mov   ebx,[edi.nDigit]  // 
    mov   esi,[edi]
#else
    mov   ebx,[edi+NDIGIT]
    mov   esi,[edi+DIGIT]
#endif

    mov   ecx,n
    or    ecx,ecx               // is n zero ?
    jg    try_div
    neg   ecx                         // ΒlŏZ
  }
try_div:
  __asm {
    xor edx,edx
	dec ebx
	js  Set
  }
DIVIDE:
  __asm {                             // ŏʂ̌珇Ɋ
    mov   eax,[ebx*NBYTE+esi]
    div   ecx
    dec   ebx
    jns   DIVIDE

    mov   eax,edx
  }
  __asm {
#ifdef __BORLANDC__
    cmp   dword ptr [edi.nDim],0      // l
#else
    cmp   dword ptr [edi+NDIM],0
#endif
    jg    OK
    neg   edx                         // this ̕ɍ킹
  }
OK:
  __asm {
    cmp   RemType,SameSignRem         // ߂̂͂ӂ̏]
    je    Set                         // 
    cmp   RemType,AbsoluteRem         // Βlŏ]
    jne   PosRem
    mov   ebx,ecx
    shr   ebx,1                       // n/2
    cmp   eax,ebx                     // |r|<=n/2 ?
    jle   Set                         // yes
    or    edx,edx
    jle   BBBB
    sub   eax,ecx                     // |r|-edx  (edx<0)
    mov   edx,eax
    jmp   Set
  }
PosRem:
  __asm {
    or    edx,edx                     // is remainder 0 ? 
    jge   Set                         // 0ȏȂ OK
  }
BBBB:
  __asm {
    add   edx,ecx                     // edx=n+edx  ( edx<0 )
  }
Set:
  __asm {
    mov   n,edx                       // ]Z[u
  }
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return n ;
}

